/********************************** (C) COPYRIGHT *******************************
* File Name          : DataFlash.C
* Author             : WCH
* Version            : V1.0
* Date               : 2018/08/09
* Description        : CH549 DataFlashֽڶд
*******************************************************************************/
#include ".\FlashRom\FlashRom.H"
#pragma  NOAREGS
/*******************************************************************************
* Function Name  : ErasePage( UINT16 Addr )
* Description    : ҳÿ64ֽΪһҳҳݱΪ0x00
* Input          : Addr:ַҳ
* Output         : None
* Return         : ز״̬0x00:ɹ  0x01:ַЧ  0x02:δ֪ʱ
*******************************************************************************/
UINT8 FlashErasePage( UINT16 Addr )
{
    bit e_all;
    UINT8 status;                                    /* ز״̬ */
    UINT8 FlashType;                                 /* Flash ͱ־ */
    e_all = EA;
    EA = 0;                                          /* رȫж,ֹFlash */
    Addr &= 0xFFC0;                                  /* 64ֽڶ */
    if((Addr>=DATA_FLASH_ADDR) && (Addr<BOOT_LOAD_ADDR))/* DataFlash */
    {
        FlashType = bDATA_WE;
    }
    else                                             /* CodeFlash */
    {
        FlashType = bCODE_WE;
    }
    SAFE_MOD = 0x55;                                 /* 밲ȫģʽ */
    SAFE_MOD = 0xAA;
    GLOBAL_CFG |= FlashType;
    ROM_ADDR = Addr;                                 /* дĿַ */
    ROM_BUF_MOD = bROM_BUF_BYTE;                     /* ѡģʽֽڱģʽ */
    ROM_DAT_BUF = 0;                                 /* дݻĴΪ0 */
    if ( ROM_STATUS & bROM_ADDR_OK )                 /* ַЧ */
    {
        ROM_CTRL = ROM_CMD_ERASE;                    /*  */
        if(ROM_STATUS & bROM_CMD_ERR)
        {
            status = 0x02;    /* δ֪ʱ */
        }
        else
        {
            status = 0x00;    /* ɹ */
        }
    }
    else
    {
        status = 0x01;    /* ַЧ */
    }
    SAFE_MOD = 0x55;                                 /* 밲ȫģʽ */
    SAFE_MOD = 0xAA;
    GLOBAL_CFG &= ~FlashType;                        /* д */
    EA = e_all;                                      /* ָȫж״̬ */
    return status;
}
/*******************************************************************************
* Function Name  : FlashProgByte(UINT16 Addr,UINT8 Data)
* Description    : Flash ֽڱ
* Input          : Addrдַ
*                  Dataֽڱ̵
* Output         : None
* Return         : ״̬ 0x00:ɹ  0x01:ַЧ  0x02:δ֪ʱ
*******************************************************************************/
UINT8 FlashProgByte( UINT16 Addr,UINT8 Data )
{
    bit e_all;
    UINT8 status;                                    /* ز״̬ */
    UINT8 FlashType;                                 /* Flash ͱ־ */
    e_all = EA;
    EA = 0;                                          /* رȫж,ֹFlash */
    if((Addr>=DATA_FLASH_ADDR) && (Addr<BOOT_LOAD_ADDR))/* DataFlash */
    {
        FlashType = bDATA_WE;
    }
    else                                             /* CodeFlash */
    {
        FlashType = bCODE_WE;
    }
    SAFE_MOD = 0x55;                                 /* 밲ȫģʽ */
    SAFE_MOD = 0xAA;
    GLOBAL_CFG |= FlashType;
    ROM_ADDR = Addr;                                 /* дĿַ */
    ROM_BUF_MOD = bROM_BUF_BYTE;                     /* ѡģʽֽڱģʽ */
    ROM_DAT_BUF = Data;                              /* ݻĴ */
    if ( ROM_STATUS & bROM_ADDR_OK )                 /* ַЧ */
    {
        ROM_CTRL = ROM_CMD_PROG ;                    /*  */
        if(ROM_STATUS & bROM_CMD_ERR)
        {
            status = 0x02;    /* δ֪ʱ */
        }
        else
        {
            status = 0x00;    /* ɹ */
        }
    }
    else
    {
        status = 0x01;    /* ַЧ */
    }
    SAFE_MOD = 0x55;                                 /* 밲ȫģʽ */
    SAFE_MOD = 0xAA;
    GLOBAL_CFG &= ~FlashType;                        /* д */
    EA = e_all;                                      /* ָȫж״̬ */
    return status;
}
/*******************************************************************************
* Function Name  : FlashProgPage( UINT16 Addr, PUINT8X Buf,UINT8 len )
* Description    : ҳ,̵ǰAddrҳ
* Input          : Addrдַ
*                  BufBufַĵ6λҪAddrַ6λȣҲǣBufַ%64ҳƫƵַҪͬ
*                  len: д볤ȣ64
* Output         : None
* Return         : ״̬ 0x00:ɹ  0x01:ַЧ  0x02:δ֪ʱ
*******************************************************************************/
UINT8 FlashProgPage( UINT16 Addr, PUINT8X Buf,UINT8 len )
{
    bit e_all;
    UINT8 status;                                    /* ز״̬ */
    UINT8 FlashType;                                 /* Flash ͱ־ */
    UINT8 page_offset;                               /* AddrڵǰҳƫƵַ */
    e_all = EA;
    EA = 0;                                          /* رȫж,ֹFlash */
    if((Addr>=DATA_FLASH_ADDR) && (Addr<BOOT_LOAD_ADDR))/* DataFlash */
    {
        FlashType = bDATA_WE;
    }
    else                                             /* CodeFlash */
    {
        FlashType = bCODE_WE;
    }
    SAFE_MOD = 0x55;                                 /* 밲ȫģʽ */
    SAFE_MOD = 0xAA;
    GLOBAL_CFG |= FlashType;
    page_offset = Addr & MASK_ROM_ADDR;
    if ( len > (ROM_PAGE_SIZE - page_offset) )
    {
        return( 0xFC );    /* ʼַϱдֽܳǰҳ, ÿ64ֽΪһҳ, βóǰҳ */
    }
    if ( ( (UINT8)Buf & MASK_ROM_ADDR ) != page_offset )
    {
        return( 0xFB );    /* xdataַ6λʼַ6λ */
    }
    ROM_ADDR = Addr;
    ROM_BUF_MOD = page_offset + len - 1;             /* ҳַ̽6λĵַ */
    DPL = (UINT8)Buf;
    DPH = (UINT8)( (UINT16)Buf >> 8 );
    if ( ROM_STATUS & bROM_ADDR_OK )                 /* ַЧ */
    {
        ROM_CTRL = ROM_CMD_PROG ;                    /*  */
        if(ROM_STATUS & bROM_CMD_ERR)
        {
            status = 0x02;    /* δ֪ʱ */
        }
        else
        {
            status = 0x00;    /* ɹ */
        }
    }
    else
    {
        status = 0x01;    /* ַЧ */
    }
    SAFE_MOD = 0x55;                                 /* 밲ȫģʽ */
    SAFE_MOD = 0xAA;
    GLOBAL_CFG &= ~FlashType;                        /* д */
    EA = e_all;                                      /* ָȫж״̬ */
    return status;
}
/*******************************************************************************
* Function Name  : FlashReadBuf(UINT16 Addr,PUINT8 buf,UINT16 len)
* Description    : Flashdatacode
* Input          : UINT16 Addr,PUINT8 buf,UINT16 len
* Output         : None
* Return         : ʵʶ
*******************************************************************************/
UINT8 FlashReadBuf(UINT16 Addr,PUINT8 buf,UINT16 len)
{
    UINT16 i;
    for(i=0; i!=len; i++)
    {
        buf[i] = *(PUINT8C)Addr;
        if(Addr==0xFFFF)
        {
            i++;
            break;
        }
        Addr++;
    }
    return i;
}
/*******************************************************************************
* Function Name  : FlashProgOTPbyte( UINT8 Addr, UINT8 Data )
* Description    : ֽдOTPֻ01,Ҳɲ
* Input          : Addr0x20~0x3F
*                  Data:
* Output         : None
* Return         : ״̬ 0x00:ɹ  0x02:δ֪ʱ
*******************************************************************************/
UINT8 FlashProgOTPbyte( UINT8 Addr, UINT8 Data )
{
    bit e_all;
    UINT8 status;                                    /* ز״̬ */
    e_all = EA;
    EA = 0;                                          /* رȫж,ֹFlash */
    SAFE_MOD = 0x55;                                 /* 밲ȫģʽ */
    SAFE_MOD = 0xAA;
    GLOBAL_CFG |= bDATA_WE;
    ROM_ADDR = Addr;
    ROM_BUF_MOD = bROM_BUF_BYTE;
    ROM_DAT_BUF = Data;
    ROM_CTRL = ROM_CMD_PG_OTP;
    if(ROM_STATUS & bROM_CMD_ERR)
    {
        status = 0x02;    /* δ֪ʱ */
    }
    else
    {
        status = 0x00;    /* ɹ */
    }
    SAFE_MOD = 0x55;                                 /* 밲ȫģʽ */
    SAFE_MOD = 0xAA;
    GLOBAL_CFG &= ~bDATA_WE;                         /* д */
    EA = e_all;                                      /* ָȫж״̬ */
    return status;
}
/*******************************************************************************
* Function Name  : FlashReadOTPword( UINT8 Addr )
* Description    : 4ֽΪλȡReadOnlyOTP
* Input          : Addr0x00~0x3F
* Output         : None
* Return         : ȡֽ
*******************************************************************************/
UINT32 FlashReadOTPword( UINT8 Addr )
{
    UINT32 temp;
    ROM_ADDR = Addr;
    ROM_CTRL = ROM_CMD_RD_OTP;
    temp = ROM_DATA_HI;
    temp <<= 16;
    temp |= ROM_DATA_LO;
    return temp;
}
