/********************************** (C) COPYRIGHT *******************************
* File Name          : Timer.C
* Author             : WCH
* Version            : V1.0
* Date               : 2018/08/21
* Description        : CH549 Time ʼʱֵT2׽ܿ
                       ʱжϺ
*******************************************************************************/
#include ".\Timer\Timer.H"
#pragma  NOAREGS
#ifdef  T2_CAP
UINT16 Cap2[2] = {0};
UINT16 Cap1[2] = {0};
UINT16 Cap0[2] = {0};
#endif
/*******************************************************************************
* Function Name  : mTimer_x_ModInit(UINT8 x ,UINT8 mode)
* Description    : CH549ʱxģʽ
* Input          : UINT8 mode,Timerģʽѡ
                   0ģʽ013λʱTLnĸ3λЧ
                   1ģʽ116λʱ
                   2ģʽ28λԶװʱ
                   3ģʽ38λʱ  Timer0
                   3ģʽ3Timer1ֹͣ
* Output         : None
* Return         : ɹ  SUCCESS
                   ʧ  FAIL
*******************************************************************************/
UINT8 mTimer_x_ModInit(UINT8 x ,UINT8 mode)
{
    if(x == 0)
    {
        TMOD = TMOD & 0xf0 | mode;
    }
    else if(x == 1)
    {
        TMOD = TMOD & 0x0f | (mode<<4);
    }
    else if(x == 2)
    {
        RCLK = 0;    //16λԶضʱ
        TCLK = 0;
        CP_RL2 = 0;
    }
    else
    {
        return FAIL;
    }
    return SUCCESS;
}
/*******************************************************************************
* Function Name  : mTimer_x_SetData(UINT8 x,UINT16 dat)
* Description    : CH549Timer0 TH0TL0ֵ
* Input          : UINT16 dat;ʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void mTimer_x_SetData(UINT8 x,UINT16 dat)
{
    UINT16 tmp;
    tmp = 65536 - dat;
    if(x == 0)
    {
        TL0 = tmp & 0xff;
        TH0 = (tmp>>8) & 0xff;
    }
    else if(x == 1)
    {
        TL1 = tmp & 0xff;
        TH1 = (tmp>>8) & 0xff;
    }
    else if(x == 2)
    {
        RCAP2L = TL2 = tmp & 0xff;                                               //16λԶضʱ
        RCAP2H = TH2 = (tmp>>8) & 0xff;
    }
}
/*******************************************************************************
* Function Name  : CAP2Init(UINT8 mode)
* Description    : CH549ʱ2 T2EXŲ׽ܳʼCAP2 P11
                   UINT8 mode,ز׽ģʽѡ
                   0:T2ex½صһ½
                   1:T2ex֮
                   3:T2exصһ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CAP2Init(UINT8 mode)
{
    RCLK = 0;
    TCLK = 0;
    C_T2  = 0;
    EXEN2 = 1;
    CP_RL2 = 1;                                                                //T2exĲ׽
    T2MOD |= mode << 2;                                                        //ز׽ģʽѡ
}
/*******************************************************************************
* Function Name  : CAP1Init(UINT8 mode)
* Description    : CH549ʱ2 T2Ų׽ܳʼT2(CAP1 P10)
                   UINT8 mode,ز׽ģʽѡ
                   0:T2ex½صһ½
                   1:T2ex֮
                   3:T2exصһ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CAP1Init(UINT8 mode)
{
    RCLK = 0;
    TCLK = 0;
    CP_RL2 = 1;
    C_T2 = 0;
    T2MOD = T2MOD & ~T2OE | (mode << 2) | bT2_CAP1_EN;                         //ʹT2Ų׽,ز׽ģʽѡ
}
/*******************************************************************************
* Function Name  : CAP0Init(UINT8 mode)
* Description    : CH549ʱ2 CAP0Ų׽ܳʼ(CAP0 P36)
                   UINT8 mode,ز׽ģʽѡ
                   0:T2ex½صһ½
                   1:T2ex֮
                   3:T2exصһ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CAP0Init(UINT8 mode)
{
    RCLK = 0;
    TCLK = 0;
    CP_RL2 = 1;
    C_T2 = 0;
    T2MOD |= mode << 2;                                                        //ز׽ģʽѡ
    T2CON2 = bT2_CAP0_EN;
}
#ifdef T0_INT
/*******************************************************************************
* Function Name  : mTimer0Interrupt()
* Description    : CH549ʱ0ʱжϴ 1msж
*******************************************************************************/
void mTimer0Interrupt( void ) interrupt INT_NO_TMR0 using 1                    //timer0жϷ,ʹüĴ1
{
    mTimer_x_SetData(0,2000);                                                 //ģʽ1 ¸TH0TL0ֵ
    SCK = ~SCK;                                                               //Լ1ms
}
#endif
#ifdef T1_INT
/*******************************************************************************
* Function Name  : mTimer1Interrupt()
* Description    : CH549ʱ1ʱжϴ 100usж
*******************************************************************************/
void mTimer1Interrupt( void ) interrupt INT_NO_TMR1 using 2                //timer1жϷ,ʹüĴ2
{
    //ʽ2ʱTimer1Զװ
    static UINT16 tmr1 = 0;
    tmr1++;
    if(tmr1 == 2000)                                                       //100us*2000 = 200ms
    {
        tmr1 = 0;
        SCK = ~SCK;
    }
}
#endif
/*******************************************************************************
* Function Name  : mTimer2Interrupt()
* Description    : CH549ʱ0ʱжϴ
*******************************************************************************/
void mTimer2Interrupt( void ) interrupt INT_NO_TMR2 using 3                //timer2жϷ,ʹüĴ3
{
#ifdef  T2_INT
    static UINT8 tmr2 = 0;
    if(TF2)
    {
        TF2 = 0;                                                             //նʱ2ж,ֶ
        tmr2++;
        if(tmr2 == 100)                                                      //200msʱ䵽
        {
            tmr2 = 0;
            SCK = ~SCK;                                                      //P17ƽָʾ
        }
    }
#endif

#ifdef  T2_CAP
    if(EXF2)                                                                //T2exƽ仯жжϱ־
    {
        Cap2[0] = RCAP2;                                                    //T2EX
        printf("CAP2 %04x\n",Cap2[0]-Cap2[1]);
        Cap2[1] = Cap2[0];
        EXF2 = 0;                                                           //T2ex׽жϱ־
    }
    if(CAP1F)                                                               //T2ƽ׽жϱ־
    {
        Cap1[0] = T2CAP1;                                                    //T2;
        printf("CAP1 %04x\n",Cap1[0]-Cap1[1]);
        Cap1[1] = Cap1[0];
        CAP1F = 0;                                                          //T2׽жϱ־
    }
    if(T2CON2&bT2_CAP0F)
    {
        Cap0[0] = T2CAP0;
        printf("CAP0 %04x\n",Cap0[0]-Cap0[1]);
        Cap0[1] = Cap0[0];
        T2CON2 &= ~bT2_CAP0F;
    }
#endif

}
