/********************************** (C) COPYRIGHT *******************************
* File Name          : PD.H
* Author             : WCH
* Version            : V1.00
* Date               : 018/09/15
* Description        :
*******************************************************************************/
#ifndef __PD_H__
#define __PD_H__
#include "CH549.H"
#include "DEBUG.H"
/*******************************************************************************
 *     GPIO            Function
 *     P14               CC1
 *     P15               CC2
 *     P11               PD ͨѶ״̬
 *******************************************************************************/

/* Դƿ/״ָ̬ʾ
    ضΪ0Ϊ1
*/
sbit VBUSG = P1^1;
/* Դɫ궨 */
#define     SINK                    0
#define     SOURCE                  1
/* ѡSOURCE SINK ֻѡ1 */
#define     POWER_ROLE              SINK
#define     CC_CHAN_1               1
#define     CC_CHAN_2               2
#define     CC_AD_CHAN_1            4
#define     CC_AD_CHAN_2            5
/* CCż⵽ADCֵжϹ */
/*  ʵʵѹ                ADCʵֵ(ADCƫѹ5V12λ)
    ǵCC5V3.3VCC߼ѹҪ
 * +---------+----------+-------+
 * | 0.4 V   | Default  | 342   |
 * | 0.9 V   | 1.5A     | 771   |
 * | 1.6 V   | 3.0A     | 1383  |
 * +---------+----------+-------+

*/
#define     DEFAULT_POWER_MIN       (342-137)
#define     DEFAULT_POWER_MAX       (342+158)
#define     POWER_1A5_MIN           (771-198)
#define     POWER_1A5_MAX           (771+180)
#define     POWER_3A0_MIN           (1383-310)
#define     POWER_3A0_MAX           (1383+288)
/* PD Ϣ궨 */
#define     SOURCE_SEND_CAP         0x01                                            /* 5B:00001 */
#define     GOOD_CRC                0x01                                            /* 5B:00001 */
#define     SINK_SEND_REQUEST       0x02                                            /* 5B:00010 */
#define     SOURCE_SEND_ACCEPT      0x03                                            /* 5B:00011 */
#define     REJECT                  0x04                                            /* 5B:00100 */
#define     PS_RDY                  0x06                                            /* 5B:00110 */
/* DFP״̬ */
#define     DFP_DEFAULT_CURRENT     0X01
#define     DFP_1_5_A               0X02
#define     DFP_3_0_A               0X03
#define     DFP_DISCONNECT          0XFF
#define     DFP_STAT_DISCONNECT     0X00
#define     DFP_STAT_CONNECT        0X01
/*********************************************************************************************************/
/* SOURCE ˺궨*/
/* UFP״̬ */
#define     UCC_DISCONNECT          0x00                                            //豸δ
#define     UCC1_CONNECT            0x01                                            //
#define     UCC2_CONNECT            0x02                                            //
/*
 * 5ѹλSource Capability
 * Ҫĵλó0,5VڣұΪVOLT1,5Vɵ
*/
/* ѹλ1mV */
#define     VOLT1                   5000
#define     VOLT2                   9000
#define     VOLT3                   15000
#define     VOLT4                   20000
#define     VOLT5                   25000
/* λ1mA */
#define     AMP1                    3000
#define     AMP2                    1800
#define     AMP3                    1500
#define     AMP4                    1200
#define     AMP5                    1000
/* ⲿñ */
extern UINT8X CCSel;                                                                /* PDͨѶCCӹܽ: 1CC1  2CC2 */
/* ⲿӺ */
/*******************************************************************************
* Function Name  : Timer0Init()
* Description    : ʹTimer0ʱģʽ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
extern void  Timer0Init( );
/*******************************************************************************
* Function Name  : PD_Init()
* Description    : Type-C UPFģʽ,ADC
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
extern void  PD_Sink_Init( );
/*******************************************************************************
* Function Name  : Connect_Check(void)
* Description    : UPFDPF
* Input          : None
* Output         : None
                   1 Ĭϵ
                   2 1.5A
                   3 3.0A
                   0xff 
*******************************************************************************/
extern UINT8 Connect_Check( void );
/*******************************************************************************
* Function Name  : ResetSndHeader
* Description    : ʼͷĬֵ
* Input          : NONE
* Output         : None
* Return         : None
*******************************************************************************/
extern void  ResetSndHeader (void);
/*******************************************************************************
* Function Name  : SendHandle
* Description    : ײ㷢ͺ,GOODCRCĽ
*                  PRESOFCRC32EOP,Ȼ4B5B롢BMC
* Input          : CC_Sel,ʾõCC
* Output         : None
* Return         : ״̬
*                  0x00: ͳɹ
*                  0x01: ʧ
*******************************************************************************/
extern UINT8 SendHandle ( UINT8 CC_Sel );
/*******************************************************************************
* Function Name  : ReceiveHandle
* Description    : ײպ,GOODCRCķ
*                  PRESOFCRC32EOP
* Input          : CC_Sel,ʾõCC
* Output         : None
* Return         : 0x00:յݰ
*                  0x01:ûյ
*******************************************************************************/
extern UINT8 ReceiveHandle ( UINT8 CC_Sel ) ;
/*******************************************************************************
* Function Name  : SearchVoltage
* Description    : Voltѹӽ
* Input          : Volt,ѹֵλ mV
* Output         : None
* Return         : ֵ
*                  0xFF,СҲĴҲѹֵ
*******************************************************************************/
extern UINT8 SearchVoltage ( UINT16 Volt );
/*******************************************************************************
* Function Name  : PrepareReqData
* Description    : ׼Requestݰ
* Input          : Index : SearchVoltage()صֵ
* Output         : NONE
* Return         : NONE
*******************************************************************************/
extern void PrepareReqData(UINT8 index);
/*******************************************************************************
* Function Name  : GetMsgType
* Description    : ȡǰϢ״̬ʶ
* Input          : NONE
* Output         : NONE
* Return         : Ϣ
*******************************************************************************/
extern UINT8 GetMsgType(void);
/* PD SOURCE  */
/*******************************************************************************
* Function Name  : PD_Source_Init()
* Description    : Type-C UPFʼʼΪ3A
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
extern void PD_Source_Init( void );
/*******************************************************************************
* Function Name  : DFP_Insert(void)
* Description    : DPFUFP壬ԼδѲ
* Input          : None
* Output         : None
* Return         : 0   δ
                   1   
                   2   
*******************************************************************************/
extern UINT8 DFP_Insert( void );
/*******************************************************************************
* Function Name  : Config_SourceCap
* Description    :  Source Capability
* Input          : None
* Return         : None
*******************************************************************************/
extern UINT8 Config_SourceCap(void);
/*******************************************************************************
* Function Name  : SetMsgType
* Description    : Ϣ
* Input          : None
* Return         : None
*******************************************************************************/
extern void SetMsgType(UINT8 t_msgType);
#endif
